HDU 2955 变形较大的01背包(有意思,新思路)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2955

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 29618    Accepted Submission(s): 10834


Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.


His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

 

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

 

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

 

Sample Input
3 0.04 3 1 0.02 2 0.03 3 0.05 0.06 3 2 0.03 2 0.03 3 0.05 0.10 3 1 0.03 2 0.02 3 0.05
 

 

Sample Output
2 4 6
 
分析:
英文题目是真的很难理解啊。。。。。
 
先是给出几组数据,每组数据第一行是总被抓概率p(最后求得的总概率必须小于他,否则被抓),然后是想抢的银行数n。然后n行,每行分别是该银行能抢的钱数m[i]和被抓的概率p[i],在成功逃跑的前提下获得的最大钱数
 
 
开始是想将被抓的概率当作背包总容量,每个银行的钱当作物品价值,被抓概率当作物品重量,这样思路确实是对的,但是这题的数据很毒,被每个银行被抓的概率精度是不确定的,不一定是小数点后两位,可能是0.00001,所以概率乘以100是没有用的,乘太大也就会超出数组的下标界限
所以转变思维:
 
将银行钱总数当作背包的容量,每个银行逃跑的概率做价值,每个银行的钱数当作重量
这样问题就转变成了怎么拿可以使得逃跑概率最大
dp[k]的意义:拿k钱的时候的成功逃跑概率
从后往前遍历dp数组,找到第一个dp[k]大于题目给出的逃跑概率限制条件,这个时候的k值就是可以获得的最大钱数
注意:
1.题目给的限制概率是被抓的概率(p),逃跑的概率=1-被抓的概率
小偷偷完之后被抓的概率要小于p,小偷偷完之后逃跑的概率要大于(1-p)
2.每个银行题目给的概率是偷每个银行被抓的概率,偷每个银行成功逃跑的概率=(1-偷每个银行被抓的概率)
3.成功逃跑的概率等于偷每个银行成功逃跑概率的乘积
 
emmm,应该注意点就这些
放代码:
#include<bits/stdc++.h>
using namespace std;
#define max_v 10005
double dp[max_v];//拿k钱的时候的成功逃跑概率
int w[max_v];//每个银行的钱数当作重量
double v[max_v];//每个银行逃跑的概率做价值
//所有银行的总钱数做背包容量
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        double p;
        int n;
        int sum=0;
        scanf("%lf %d",&p,&n);
        for(int i=0;i<n;i++)
        {
            scanf("%d %lf",&w[i],&v[i]);
            sum=sum+w[i];
        }
        memset(dp,0,sizeof(dp));
        dp[0]=1;
        for(int i=0;i<n;i++)
        {
            for(int j=sum;j>=w[i];j--)
            {
                dp[j]=max(dp[j],dp[j-w[i]]*(1-v[i]));
            }
        }
       for(int i=sum;i>=0;i--)
       {
           if(dp[i]>(1-p))
           {
               printf("%d\n",i);
               break;
           }
       }
    }
    return 0;
}

 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值